require 'yaml'
require 'easy_type/puppet_service'

module EasyType
class Classifier < PuppetService
  def initialize
    super
    port         = 4433
    prefix       = '/classifier-api' 
    @base_url    = "https://#{@server}:#{port}#{prefix}"
  end

  #
  # The top level group containin all licensed nodes
  def em_group
    'EM licensed nodes'
  end

  def find_by_name(name)
    node_groups.find {|g| g['name'] == name }
  end

  def find_by_id(id)
    node_groups.find {|g| g['id'] == id }
  end

  def node_groups
    return @node_groups if @node_groups
    @node_groups = get('/v1/groups')
  end

  def em_groups
    node_groups.select {|g| em_group?(g) }
  end

  def full_name_for(group)
    value = [group['name']]
    current_group = group
    while true do
      parent_group = node_groups.find {|g| g['id'] == current_group['parent'] }
      break if current_group['id'] == parent_group['id']
      value << parent_group['name']
      current_group = parent_group
    end
    group['full_name'] = "/#{value.reverse.join('/')}"
  end

  def em_group?(group)
    full_name_for(group).include?(em_group)
  end

  def rule_to_pdb_query(rules)
    post('/v1/rules/translate', rules)
  end
end
end